clear
data=csvread('../Applications/NatureScienceExperiments/SelectedNatureScienceColumns.csv',1,0,[1,0,21,8]);

%Read in list of names
names=readtable('../Applications/NatureScienceExperiments/NatureScienceLabels.csv');


Obs1=data(:,1);
Pval1=data(:,2);

Obs2=data(:,5);
Pval2=data(:,6);

Estimate1=data(:,3);
Estimate2=data(:,7);

Original_researcher_approval=data(:,9);

dof1O=data(:,4);
dof2O=data(:,8);

%Impute z-statistics from p-values.  When imputation produces infinite Z
%statistic, use alternative p_value
Z1=norminv(1-Pval1/2);

Z2=norminv(1-Pval2/2);

%Use Fisher Transformation to obtain approximately normal standardized
%estimates
Fisher=@(x) 0.5*log((1+x)./(1-x));
Estimate1_final=Fisher(Estimate1);
Estimate2_final=Fisher(Estimate2);

SE1=abs(Estimate1_final)./abs(Z1);
SE2=abs(Estimate2_final)./abs(Z2);

output=[Estimate1_final SE1 Estimate2_final SE2 Z1 Original_researcher_approval==1 dof1O dof2O];
%Sort list of names
[output, idx]=sortrows(output,5);
sorted_names=names(idx,:);
%drop observations for which do not have point estimate
sorted_names(output(:,3)==0,:)=[];
output(output(:,3)==0,:)=[];

%Drop column Z statistics (which included only for sorting purposes)
output(:,5)=[];

%Output data and names
csvwrite('../Applications/NatureScienceExperiments/cleaned_naturescience_data.csv',output)
writetable(sorted_names(:,1),'../Applications/NatureScienceExperiments/sorted_names.csv')
writetable(sorted_names(:,3),'../Applications/NatureScienceExperiments/sorted_1stAuthor.csv')