%options for optimization and numerical derivatives
options=optimset('MaxFunEvals',10^5,'MaxIter',10^5,'TolFun',10^-8);
%options=optimset('MaxFunEvals',10^3,'MaxIter',10^3,'TolFun',10^-8);
stepsize=10^-6;

if GMMapproach==0
    %setting the objective function
    if identificationapproach==1
        %Use replication approach
        if spec_test==1
            LLH=@(Psi) ReplicationpzthetaLogLikelihood(Psi(1), Psi(2), [Psi(3:3+length(cutoffs)-1) 1],...
                [zeros(1,length(Psi(3:3+length(cutoffs)-1))) 0], cutoffs,symmetric, Z, sigmaZ2,...
                vcutoff);
            
            LLH_test=@(Psi) ReplicationpzthetaLogLikelihood(Psi(1), Psi(2), [Psi(3:3+length(cutoffs)-1) 1],...
                [Psi(3+length(cutoffs):end) 0], cutoffs,symmetric, Z, sigmaZ2,...
                vcutoff);           
        else
            LLH = @(Psi)ReplicationAnalyticLogLikelihoodControls(Psi(1), Psi(2), ...
                [reshape(Psi(3:end)',[length(Psi(3:end))/length(cutoffs),length(cutoffs)]) [1;zeros(size(C,2)-1,1)]]...
                ,cutoffs,symmetric, Z, sigmaZ2,C,numerical_integration);
        end
        nn=n;
    elseif  identificationapproach==2
        %Use metastudy approach
        
        if asymmetric_likelihood_spec==2
            if symmetric_p==1
                %For this case, not currently written to use controls
                LLH = @(Psi) VariationVarianceLogLikelihoodtdist(Psi(1), Psi(2),...
                    Psi(3), [1 Psi(4:end) fliplr(Psi(4:end)) 1]...
                    ,cutoffs,symmetric, X(includeinestimation), sigma(includeinestimation),C(includeinestimation,:),numerical_integration);
                nn=sum(includeinestimation);
            else
                %Run model with t distribution for latent effects
                
                if time_trend==1
                    LLH = @(Psi) VariationVarianceLogLikelihoodtdist_logit(Psi(1), Psi(2),Psi(3),...
                        [reshape(Psi(4:end)',[length(Psi(4:end))/length(cutoffs),length(cutoffs)]) [1;zeros(size(C,2)-1,1)]]...
                        ,cutoffs,symmetric, X(includeinestimation), sigma(includeinestimation),C(includeinestimation,:),numerical_integration);
                    nn=n;
                else
                    2+2
                    LLH = @(Psi) VariationVarianceLogLikelihoodtdist(Psi(1), Psi(2),Psi(3),...
                        [reshape(Psi(4:end)',[length(Psi(4:end))/length(cutoffs),length(cutoffs)]) [1;zeros(size(C,2)-1,1)]]...
                        ,cutoffs,symmetric, X(includeinestimation), sigma(includeinestimation),C(includeinestimation,:),numerical_integration);
                    nn=n;
                end
            end
            
        else
            if symmetric_p==1
                %For this case, not currently written to use controls
                LLH = @(Psi) VariationVarianceLogLikelihoodControls(Psi(1), Psi(2),...
                    [1 Psi(3:end) fliplr(Psi(3:end)) 1]...
                    ,cutoffs,symmetric, X(includeinestimation), sigma(includeinestimation),C(includeinestimation,:),numerical_integration);
                nn=sum(includeinestimation);
            else
                
                %Run model with normal distribution for latent effects
                LLH = @(Psi) VariationVarianceLogLikelihoodControls(Psi(1), Psi(2),...
                    [reshape(Psi(3:end)',[length(Psi(3:end))/length(cutoffs),length(cutoffs)]) [1;zeros(size(C,2)-1,1)]]...
                    ,cutoffs,symmetric, X(includeinestimation), sigma(includeinestimation),C(includeinestimation,:),numerical_integration);
                nn=sum(includeinestimation);
            end
        end
    end
    
    %find maximum likelihood estimator using just LLH
    if spec_test==1
        [Psihat1, LLHmax] = fminunc(LLH,Psihat0,options);
        [Psihat, LLHmax] = fminsearch(LLH,Psihat1,options);
        
        Psihat_test=[Psihat zeros(1,length(cutoffs))];
        score_mat=zeros(n , length(Psihat_test));
        for n1=1:length(Psihat_test)
            theta_plus=Psihat_test;
            theta_plus(n1)=theta_plus(n1)+stepsize;
            [LLH_plus, logL_plus]=LLH_test(theta_plus);
            theta_minus=Psihat_test;
            theta_minus(n1)=theta_minus(n1)-stepsize;
            [LLH_minus, logL_minus]=LLH_test(theta_minus);
            score_mat(:,n1)=(logL_plus-logL_minus)/(2*stepsize);
        end
        
        score_stat=n*mean(score_mat)*cov(score_mat)^-1*mean(score_mat)';
        score_pval=1-chi2cdf(score_stat,length(cutoffs));
        
    else
        if application==23
            LLHmod=@(Psishort) LLH([Psishort(1) Psishort(2) 0 Psishort(3)]);
            Psishort0=[Psihat0(1) Psihat0(2) Psihat0(4)];
            [Psihatshort1, LLHmax] = fminunc(LLHmod,Psishort0,options);
            [Psihatshort, LLHmax] = fminsearch(LLHmod,Psihatshort1,options);
            Var_robust_short=RobustVariance(stepsize, nn, Psihatshort, LLHmod,cluster_ID);
            se_robust_short=diag(Var_robust_short).^.5;
            
            Psihat=[Psihatshort(1) Psihatshort(2) 0 Psihatshort(3)];
            se_robust=[se_robust_short(1); se_robust_short(2); 0; se_robust_short(3)];
            
        else
        [Psihat1, LLHmax] = fminunc(LLH,Psihat0,options);
        [Psihat, LLHmax] = fminunc(LLH,Psihat1,options);
        
        Var_robust=RobustVariance(stepsize, nn, Psihat, LLH,cluster_ID);
        se_robust=diag(Var_robust).^.5;

        end
        SelectionTable(Psihat,se_robust,name,(identificationapproach==1),symmetric)
    end
    
    %find the robust variance matrix
    
    % sanity check for replication studies
    if identificationapproach==1 && spec_test==0
        if application==23
                    LLH = @(Psi) VariationVarianceLogLikelihoodControls(Psi(1), Psi(2), ...
            [reshape(Psi(3:end)',[length(Psi(3:end))/length(cutoffs),length(cutoffs)]) [1;zeros(size(C,2)-1,1)]]...
            ,cutoffs,symmetric, X, sigma,C,numerical_integration);
        
            LLHmod=@(Psishort) LLH([Psishort(1) Psishort(2) 0 Psishort(3)]);
            Psishort0=[Psihat0(1) Psihat0(2) Psihat0(4)];
            [PsihatshortSanity1, LLHmax] = fminunc(LLHmod,Psishort0,options);
            [PsihatshortSanity, LLHmax] = fminsearch(LLHmod,PsihatshortSanity1,options);
            
            Var_robust_shortSanity=RobustVariance(stepsize, nn, Psihatshort, LLHmod,cluster_ID);
            se_robust_shortSanity=diag(Var_robust_shortSanity).^.5;
            
            Var_robust=[Var_robust_shortSanity(:,1:2), zeros(3,1), Var_robust_shortSanity(:,end)];
            Var_robust=[Var_robust(1:2,:); zeros(1,4); Var_robust(end,:)];
            PsihatSanity=[PsihatshortSanity(1) PsihatshortSanity(2) 0 PsihatshortSanity(3)];
            se_robustSanity=[se_robust_shortSanity(1); se_robust_shortSanity(2); 0; se_robust_shortSanity(3)];
            
        else
        LLH = @(Psi) VariationVarianceLogLikelihoodControls(Psi(1), Psi(2), ...
            [reshape(Psi(3:end)',[length(Psi(3:end))/length(cutoffs),length(cutoffs)]) [1;zeros(size(C,2)-1,1)]]...
            ,cutoffs,symmetric, X, sigma,C,numerical_integration);
        [PsihatSanity1, LLHmax] = fminunc(LLH,Psihat0,options);
        [PsihatSanity, LLHmax] = fminsearch(LLH,PsihatSanity1,options);
        Var_robustSanity=RobustVariance(stepsize, nn, PsihatSanity, LLH,cluster_ID);
        se_robustSanity=diag(Var_robustSanity).^.5;
        end
        
        SelectionTable(PsihatSanity,se_robustSanity,[name 'Sanitycheck'],0,symmetric)
    end
    
else
    if identificationapproach==1
        %%
        %Estimate model with replication moments
        GMM_obj=@(Psi)...
            ReplicationGMMObjective([Psi 1], cutoffs, symmetric, Z, sigmaZ2,momentchoice)+max(-min(Psi),0)*10^5;
        
        [Psihat1, Objval] = fminunc(GMM_obj,Psihat0,options);
        [Psihat, Objval] = fminsearch(GMM_obj,Psihat1,options);
        
        moments=ReplicationMoments([Psihat 1], cutoffs, symmetric, Z, sigmaZ2,momentchoice);
        Sigma_hat=cov(moments);
        stepsize=10^-3;
        G=zeros(size(moments,2),length(Psihat));
        for n1=1:length(Psihat)
            beta_plus=Psihat;
            beta_plus(n1)=beta_plus(n1)+stepsize;
            moments_plus=ReplicationMoments([beta_plus 1], cutoffs, symmetric, Z, sigmaZ2,momentchoice);
            beta_minus=Psihat;
            beta_minus(n1)=beta_minus(n1)-stepsize;
            moments_minus=ReplicationMoments([beta_minus 1], cutoffs, symmetric, Z, sigmaZ2,momentchoice);
            G(:,n1)=mean((moments_plus-moments_minus)/(2*stepsize))';
        end
        Varhat=(G'*Sigma_hat^-1*G)^-1/size(moments,1);
        se_robust=diag(Varhat).^.5;
        dof=size(moments,2);
        
        if length(cutoffs)==1
            
            Psi_grid=[0.001:.001:5 10 10^5];
            S_store=zeros(length(Psi_grid),1);
            
            for m=1:length(Psi_grid)
                S_store(m,1)=GMM_obj(Psi_grid(m));
            end
            
            CS_LB=min(Psi_grid(S_store<chi2inv(.95,1)));
            CS_UB=max(Psi_grid(S_store<chi2inv(.95,1)));
            
        elseif length(cutoffs)==2
            gridsteps=200;
            Psi_grid1=[0.01:(.25-0.01)/(gridsteps-1):.25];
            Psi_grid2=[0.02:(2-0.02)/(gridsteps-1):2];
            S_store=zeros(length(Psi_grid1),length(Psi_grid2));
            for m1=1:length(Psi_grid1)
                for m2=1:length(Psi_grid2)
                    Psi_temp=[Psi_grid1(m1) Psi_grid2(m2)];
                    S_store(m1,m2)=GMM_obj(Psi_temp);
                end
            end
            
            Psi_grid=[Psi_grid1' Psi_grid2'];
            
            
            
        end
        SelectionTableGMM(Psihat,se_robust,name,S_store,Psi_grid,dof)
        
        %%
        %Estimate model with metastudy moments as a check
        GMM_obj=@(Psi)...
            MetastudyGMMObjective([Psi 1], cutoffs, symmetric, X, sigma,cluster_ID)+max(-min(Psi),0)*10^5;
        
        [PsihatSanity0, Objval] = fminunc(GMM_obj,Psihat0,options);
        [PsihatSanity, Objval] = fminsearch(GMM_obj,PsihatSanity0,options);
        
        [moments, Sigma_temp, rhat]=MetastudyMoments([PsihatSanity 1], cutoffs, symmetric, X, sigma);
        Sigma_hat=Clustered_covariance_estimate(rhat,cluster_ID);
        
        stepsize=10^-3;
        G=zeros(size(moments,2),length(PsihatSanity));
        for n1=1:length(PsihatSanity)
            beta_plus=PsihatSanity;
            beta_plus(n1)=beta_plus(n1)+stepsize;
            moments_plus=MetastudyMoments([beta_plus 1], cutoffs, symmetric, X, sigma);
            beta_minus=PsihatSanity;
            beta_minus(n1)=beta_minus(n1)-stepsize;
            moments_minus=MetastudyMoments([beta_minus 1], cutoffs, symmetric, X, sigma);
            G(:,n1)=(moments_plus-moments_minus)'/(2*stepsize);
        end
        Varhat=(G'*Sigma_hat^-1*G)^-1/length(X);
        se_robustSanity=diag(Varhat).^.5;
        dof=size(moments,2);
        
        if length(cutoffs)==1
            
            Psi_grid=[0.001:.001:5 10 10^5];
            S_storeSanity=zeros(length(Psi_grid),1);
            
            for m=1:length(Psi_grid)
                S_storeSanity(m,1)=GMM_obj(Psi_grid(m));
            end
            
            CS_LB=min(Psi_grid(S_storeSanity<chi2inv(.95,1)));
            CS_UB=max(Psi_grid(S_storeSanity<chi2inv(.95,1)));
            
        elseif length(cutoffs)==2
            gridsteps=200;
            Psi_grid1=[0.01:(.25-0.01)/(gridsteps-1):.25];
            Psi_grid2=[0.02:(2-0.02)/(gridsteps-1):2];
            S_storeSanity=zeros(length(Psi_grid1),length(Psi_grid2));
            for m1=1:length(Psi_grid1)
                for m2=1:length(Psi_grid2)
                    Psi_temp=[Psi_grid1(m1) Psi_grid2(m2)];
                    S_storeSanity(m1,m2)=GMM_obj(Psi_temp);
                end
            end
            Psi_grid=[Psi_grid1' Psi_grid2'];
        end
        
        SelectionTableGMM(PsihatSanity,se_robustSanity,[name 'Sanitycheck'],S_storeSanity,Psi_grid,dof)
        
    elseif identificationapproach==2
        %Estimate model with metastudy specifications
        GMM_obj=@(Psi)...
            MetastudyGMMObjective([Psi 1], cutoffs, symmetric, X, sigma,cluster_ID)+max(-min(Psi),0)*10^5;
        
        [Psihat1, Objval] = fminunc(GMM_obj,Psihat0,options);
        [Psihat, Objval] = fminsearch(GMM_obj,Psihat1,options);
        
        [moments, Sigma_temp, rhat]=MetastudyMoments([Psihat 1], cutoffs, symmetric, X, sigma);
        Sigma_hat=Clustered_covariance_estimate(rhat,cluster_ID);
        
        stepsize=10^-3;
        G=zeros(size(moments,2),length(Psihat));
        for n1=1:length(Psihat)
            beta_plus=Psihat;
            beta_plus(n1)=beta_plus(n1)+stepsize;
            moments_plus=MetastudyMoments([beta_plus 1], cutoffs, symmetric, X, sigma);
            beta_minus=Psihat;
            beta_minus(n1)=beta_minus(n1)-stepsize;
            moments_minus=MetastudyMoments([beta_minus 1], cutoffs, symmetric, X, sigma);
            G(:,n1)=(moments_plus-moments_minus)'/(2*stepsize);
        end
        Varhat=(G'*Sigma_hat^-1*G)^-1/length(X);
        se_robust=diag(Varhat).^.5;
        dof=size(moments,2);
        
        if length(cutoffs)==1
            
            Psi_grid=[0.001:.001:5 10 10^5];
            S_store=zeros(length(Psi_grid),1);
            
            for m=1:length(Psi_grid)
                S_store(m,1)=GMM_obj(Psi_grid(m));
            end
            
            CS_LB=min(Psi_grid(S_store<chi2inv(.95,1)));
            CS_UB=max(Psi_grid(S_store<chi2inv(.95,1)));
            
        elseif length(cutoffs)==2
            gridsteps=200;
            Psi_grid1=[0.01:(.25-0.01)/(gridsteps-1):.25];
            Psi_grid2=[0.05:(5-0.05)/(gridsteps-1):5];
            S_store=zeros(length(Psi_grid1),length(Psi_grid2));
            for m1=1:length(Psi_grid1)
                for m2=1:length(Psi_grid2)
                    Psi_temp=[Psi_grid1(m1) Psi_grid2(m2)];
                    S_store(m1,m2)=GMM_obj(Psi_temp);
                end
            end
            Psi_grid=[Psi_grid1' Psi_grid2'];
        else
            Psi_grid=[0.001:.001:5 10 10^5];
            S_store=zeros(length(Psi_grid),1);
        end
        
        SelectionTableGMM(Psihat,se_robust,name,S_store,Psi_grid,dof)
        
        
    end
    
end



