function [betap,partion_stack,u_stack ] = product_partition_calculate(cutoff_mat,probability_mat)
%forms betap, partion_stack, and u_stack in contexts where the publication
%probability is a step function constant on rectengular cells, and the
%publication probabilities are products of marginal publication
%probabilities
%Currently written for models with two variables, but straightforward to
%extend to higher dimensions
partition=[eye(size(cutoff_mat,2)); -eye(size(cutoff_mat,2))];
count=1;
partion_stack=cell(1);
u_stack=cell(1);
betap=0;
for n1=1:size(cutoff_mat,1)-1
    for n2=1:size(cutoff_mat,1)-1
    partion_stack{count}=partition;
    u_stack{count}=[[cutoff_mat(n1,1); cutoff_mat(n2,2)];...
        -[cutoff_mat(n1+1,1); cutoff_mat(n2+1,2)]];
    betap(count,1)=probability_mat(n1,1).*probability_mat(n2,2);
    count=count+1;
    end
end

end

