clear
theta_grid=0:.01:5;
a=1;
b=-.9;
x_L=-1.96;
x_U=1.96;
sigma=1;
plot_lower_bound=-2;


coverage_store=zeros(length(theta_grid),1);
mean_store=zeros(length(theta_grid),1);
median_store=zeros(length(theta_grid),1);
X_draws=randn(10^6,1);
U_draws=rand(10^6,1);
for n1=1:length(theta_grid)
    theta=theta_grid(n1);
    X_temp=X_draws+theta;
    keep_ind=1-((x_L<=X_temp)&(X_temp<=x_U)&(U_draws>=(a+b)));
    X_temp=X_temp(keep_ind==1);
    coverage_store(n1,1)=mean(abs(X_temp-theta)<=1.96);
    mean_store(n1,1)=mean(X_temp)-theta;
    median_store(n1,1)=median(X_temp-theta);
end

%%
%%Used in paper

theta_grid_plot=theta_grid(theta_grid>=plot_lower_bound);

fig=figure('Visible','on',...
      'PaperPosition',[0 0 6 2.5],...
      'PaperSize',[6 2.5])


subplot(1,2,1)
plot(theta_grid_plot',zeros(length(coverage_store),1),'Color',[.8 .8 .8],'LineWidth',1)
hold on
p1= plot(theta_grid_plot',[median_store], 'Color',[.4 .4 .8],'LineWidth',2)
hold off
ax = gca;
axis([0 5 -0.5 1.5])
ax.YTick=-0.5:.5:1.5;
legend(p1,{'Median Bias'},'Fontsize',9,'Location','S')
xlabel('\theta','Fontsize',9)
ylabel('Bias','Fontsize',9)
axis square

nominal_coverage=0.95*ones(length(coverage_store),1);
subplot(1,2,2)
p2=plot(theta_grid_plot',nominal_coverage,'Color',[.8 .8 .8],'LineWidth',1)
hold on
p1=plot(theta_grid_plot',coverage_store, 'Color',[.4 .4 .8],'LineWidth',2)
hold off
ax = gca;
axis([0 5 0.6 1])
ax.YTick=0.6:.1:1;
legend([p1, p2],{'True Coverage','Nominal Coverage'},'Fontsize',9,'Location','S')
xlabel('\theta','Fontsize',9)
ylabel('Coverage','Fontsize',9)
axis square

%%
print(fig,'-dpdf', '../../../FiguresandTables/Interval_truncated_bias.pdf')



%%
%PLot with darker colors for slides

theta_grid_plot=theta_grid(theta_grid>=plot_lower_bound);

fig=figure('Visible','on',...
      'PaperPosition',[0 0 10 4],...
      'PaperSize',[10 4])


subplot(1,2,1)
plot(theta_grid_plot',zeros(length(coverage_store),1),'Color',[.6 .6 .6],'LineWidth',1.5)
hold on
p1= plot(theta_grid_plot',[median_store], 'Color',[.4 .4 .8],'LineWidth',2)
hold off
ax = gca;
axis([0 5 -0.5 1.5])
ax.YTick=-0.5:.5:1.5;
legend(p1,{'Median Bias'},'Fontsize',12,'Location','NE')
xlabel('\theta','Fontsize',12)
ylabel('Bias','Fontsize',12)

nominal_coverage=0.95*ones(length(coverage_store),1);
subplot(1,2,2)
p2=plot(theta_grid_plot',nominal_coverage,'Color',[.6 .6 .6],'LineWidth',1.5)
hold on
p1=plot(theta_grid_plot',coverage_store, 'Color',[.4 .4 .8],'LineWidth',2)
hold off
ax = gca;
axis([0 5 0.6 1])
ax.YTick=0.6:.1:1;
legend([p1, p2],{'True Coverage','Nominal Coverage'},'Fontsize',12,'Location','SE')
xlabel('\theta','Fontsize',12)
ylabel('Coverage','Fontsize',12)

%%
print(fig,'-dpdf', '../../../FiguresandTables/Interval_truncated_bias_slides.pdf')
